/**
 * generated by Xtext 2.15.0
 */
package org.xtext.example.mydsl.generator;

import com.google.common.base.Objects;
import com.google.common.collect.Iterables;
import java.util.Collections;
import java.util.List;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.xtext.generator.AbstractGenerator;
import org.eclipse.xtext.generator.IFileSystemAccess2;
import org.eclipse.xtext.generator.IGeneratorContext;
import org.eclipse.xtext.xbase.lib.CollectionLiterals;
import org.eclipse.xtext.xbase.lib.InputOutput;
import org.eclipse.xtext.xbase.lib.IteratorExtensions;
import org.xtext.example.mydsl.Minisat;
import org.xtext.example.mydsl.SAT4j;
import org.xtext.example.mydsl.Solver;
import org.xtext.example.mydsl.formula.AllSolver;
import org.xtext.example.mydsl.formula.Formula;
import org.xtext.example.mydsl.formula.Test;

/**
 * Generates code from your model files on save.
 * 
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#code-generation
 */
@SuppressWarnings("all")
public class FormulaGenerator extends AbstractGenerator {
  private final EcoreUtil.Copier copier = new EcoreUtil.Copier();
  
  public <T extends EObject> T copy(final T obj) {
    EObject _copy = this.copier.copy(obj);
    return ((T) _copy);
  }
  
  @Override
  public void doGenerate(final Resource res, final IFileSystemAccess2 fsa, final IGeneratorContext context) {
    Iterable<Test> tests = Iterables.<Test>filter(IteratorExtensions.<EObject>toIterable(res.getAllContents()), Test.class);
    if ((tests != null)) {
      for (final Test t : tests) {
        {
          Solver _switchResult = null;
          String _name = t.getSolver().getName();
          if (_name != null) {
            switch (_name) {
              case "SAT4J":
                _switchResult = new SAT4j();
                break;
              case "minisat":
                _switchResult = new Minisat();
                break;
            }
          }
          final Solver sat = _switchResult;
          String _printAST = sat.printAST(this.<Formula>copy(t.getFormula()));
          String _plus = (_printAST + " is ");
          String _testSatisfiability = sat.testSatisfiability(this.<Formula>copy(t.getFormula()));
          String _plus_1 = (_plus + _testSatisfiability);
          InputOutput.<String>println(_plus_1);
        }
      }
    }
    Iterable<AllSolver> allsolver = Iterables.<AllSolver>filter(IteratorExtensions.<EObject>toIterable(res.getAllContents()), AllSolver.class);
    if ((allsolver != null)) {
      SAT4j _sAT4j = new SAT4j();
      final List<SAT4j> satSolver = Collections.<SAT4j>unmodifiableList(CollectionLiterals.<SAT4j>newArrayList(_sAT4j));
      for (final AllSolver t_1 : allsolver) {
        {
          final Minisat sat = new Minisat();
          final String equiv = sat.testSatisfiability(this.<Formula>copy(t_1.getFormula()));
          boolean flag = true;
          for (final SAT4j solv : satSolver) {
            flag = (Objects.equal(equiv, solv.testSatisfiability(this.<Formula>copy(t_1.getFormula()))) && flag);
          }
          String str = "";
          if (flag) {
            str = " are equivalent";
          } else {
            str = " are not equivalent";
          }
          String _printAST = sat.printAST(this.<Formula>copy(t_1.getFormula()));
          String _plus = ("Solvers on " + _printAST);
          String _plus_1 = (_plus + str);
          InputOutput.<String>println(_plus_1);
        }
      }
    }
  }
}
